import Koa from 'koa';
import Router from 'koa-router';
import { Model, FindOptions, CreateOptions, UpdateOptions, DestroyOptions } from 'sequelize';
declare module 'koa' {
    interface Request extends Koa.BaseRequest {
        body: any;
    }
}
declare type ACTION_TYPE = 'GET_LIST' | 'GET_ONE' | 'CREATE' | 'UPDATE' | 'DELETE';
export declare const GET_LIST: ACTION_TYPE;
export declare const GET_ONE: ACTION_TYPE;
export declare const CREATE: ACTION_TYPE;
export declare const UPDATE: ACTION_TYPE;
export declare const DELETE: ACTION_TYPE;
interface QueryOptions {
    GET_LIST?: FindOptions;
    GET_ONE?: FindOptions;
    CREATE?: CreateOptions;
    UPDATE?: UpdateOptions;
    DELETE?: DestroyOptions;
}
declare function rest<M extends Model>(prefix: string, model: {
    new (): M;
} & typeof Model, actions?: Array<string>, toJson?: (instance: M) => Promise<any>, queryOptions?: QueryOptions): Router<any, {}>;
export default rest;
